MyAddon = LibStub("AceAddon-3.0"):NewAddon("crafthelper", "AceEvent-3.0", "AceHook-3.0")

local L = {}

if GetLocale() == "deDE" then
	L["optimal"]	= "optimal";
	L["medium"]	= "normal";
	L["easy"]		= "leicht";
	L["trivial"]	= "trivial";
	L["crafthelper"] = "CraftHelper 0.1"
	L["only_show"] = "Zeigen nur Rezepte ab"
else
	L["optimal"]	= "optimal";
	L["medium"]	= "medium";
	L["easy"]		= "easy";
	L["trivial"]	= "trivial";
	L["crafthelper"] = "CraftHelper 0.1"
	L["only_show"] = "Only show recipes starting from"
end

local MODNAME	= "Crafthelper"
local VERSION = 0.1

local timeSoFar = 0
local stage = 0
local scandone

local MyAddonframe = {}

MyAddon.rdb = {}
MyAddon.header = {}

-- translate strings to numbers for better comparing
local TradeSkillLevel = { };
TradeSkillLevel["optimal"]	= 3;
TradeSkillLevel["medium"]	= 2;
TradeSkillLevel["easy"]		= 1;
TradeSkillLevel["trivial"]	= 0;
TradeSkillLevel["header"]	= -1;

-- just a debug filter
local TradeSkillNeed = 1

-- do some locals to speed things up
local	tostring = tostring
local GetTradeSkillInfo = GetTradeSkillInfo
local GetNumTradeSkills = GetNumTradeSkills
local table = table

local function print(text)
	--DEFAULT_CHAT_FRAME:AddMessage("Crafthelper: " .. tostring(text))
end

-- Events

function MyAddon:OnInitialize()
	print("init crafthelper")
end

function MyAddon:OnEnable()
	if not IsAddOnLoaded("Blizzard_TradeSkillUI") then
		print("load Blizzard_TradeSkillUI")
		LoadAddOn("Blizzard_TradeSkillUI")
	end
	print("enable crafthelper")
	MyAddon:RegisterEvent("TRADE_SKILL_SHOW", "update")
	MyAddon:RegisterEvent("TRADE_SKILL_UPDATE", "update")
	MyAddon:RegisterEvent("TRADE_SKILL_FILTER_UPDATE", "update")
	MyAddon:RegisterEvent("UPDATE_TRADESKILL_RECAST", "update")
	MyAddon:RegisterEvent("UNIT_PORTRAIT_UPDATE", "update")
--	MyAddon:RegisterEvent("SPELL_UPDATE_USABLE", "update")
	MyAddon:RegisterEvent("CHAT_MSG_SYSTEM")

	if #MyAddonframe == 0 then
		MyAddon:InitFrames()
	end

	MyAddon:RawHook("TradeSkillFrame_Update", true)
--	MyAddon:RawHook("TradeSkillSkillButton_OnClick", true)
	MyAddon:RawHook("GetFirstTradeSkill", true)
	MyAddon:RawHook("GetNumTradeSkills", true)

end

function MyAddon:GetNumTradeSkills() 
	if not MyAddonframe.test:GetChecked() then
		return MyAddon.hooks.GetNumTradeSkills()
	end
	
	if MyAddon.rdb and type(MyAddon.rdb) == 'table' then
		return #MyAddon.rdb
	end
	
	return 0
	end

function MyAddon:GetFirstTradeSkill()
	local oldid = MyAddon.hooks.GetFirstTradeSkill()
	if not MyAddonframe.test:GetChecked() then
		return MyAddon.hooks.GetFirstTradeSkill()
	end
	
	if MyAddon.Scanning then
		return 0
	end

	-- do a scan befor retun something
	if not scandone then
		MyAddon:Scan()
	else
		print("already scaned, skip scan")
	end
	
	for k,v in pairs(MyAddon.rdb) do
		if v.skillType ~= "header" then
			print("first usable tradeskill: " .. tostring(v.oldid) .. " old: "  .. tostring(oldid))
			return v.oldid
		end
	end
	return 0
end

function MyAddon:CHAT_MSG_SYSTEM (event, msg)
	local stringpattern = ERR_LEARN_RECIPE_S:gsub('(% %%s.?$?.)', '')
	if strmatch(msg, stringpattern) then
		MyAddon.header = {}
		MyAddon:update()
	end
end

function MyAddon:OnDisable()
	print("disable crafthelper")
	self:UnregisterEvent("TRADE_SKILL_SHOW", function() MyAddon.update() end)
	self:UnregisterEvent("TRADE_SKILL_UPDATE", function() MyAddon.update() end);
	self:UnregisterEvent("TRADE_SKILL_FILTER_UPDATE", function() MyAddon.update() end);
	self:UnregisterEvent("UPDATE_TRADESKILL_RECAST", function() MyAddon.update() end);

	MyAddon:Unhook("TradeSkillFrame_Update")
end

-- Hooks

function MyAddon:TradeSkillFrame_Update(this, ...)
	if not MyAddonframe.test:GetChecked() then
		return MyAddon.hooks.TradeSkillFrame_Update(...)
	end
	
	--print("first trade skil: " .. tostring(GetFirstTradeSkill()))
	if MyAddon.Scanning then
		-- expand collapse protection from MyAddon:Scan()
		return
	end

	if not scandone then
		print(" call from outside, scan and update")
		--MyAddon:update()
		--return
	end
	
	if MyAddon.Updating then
		return
	end
	MyAddon.Updating = true;
	
	local name, rank, maxRank = GetTradeSkillLine();
        
	if ( CURRENT_TRADESKILL ~= name ) then
		StopTradeSkillRepeat();
		if ( CURRENT_TRADESKILL ~= "" ) then
			-- To fix problem with switching between two tradeskills
			UIDropDownMenu_Initialize(TradeSkillInvSlotDropDown, TradeSkillInvSlotDropDown_Initialize);
			UIDropDownMenu_SetSelectedID(TradeSkillInvSlotDropDown, 1);

			UIDropDownMenu_Initialize(TradeSkillSubClassDropDown, TradeSkillSubClassDropDown_Initialize);
			UIDropDownMenu_SetSelectedID(TradeSkillSubClassDropDown, 1);
		end
		CURRENT_TRADESKILL = name;
	end

	local skillName, skillType, numAvailable, isExpanded, altVerb;
	
	local numTradeSkills = #MyAddon.rdb;
	local skillOffset = FauxScrollFrame_GetOffset(TradeSkillListScrollFrame);
	-- If no tradeskills
	if ( numTradeSkills == 0 ) then
		TradeSkillFrameTitleText:SetFormattedText(TRADE_SKILL_TITLE, GetTradeSkillLine());
		TradeSkillSkillName:Hide();
--		TradeSkillSkillLineName:Hide();
		TradeSkillSkillIcon:Hide();
		TradeSkillRequirementLabel:Hide();
		TradeSkillRequirementText:SetText("");
		TradeSkillCollapseAllButton:Disable();
		for i=1, MAX_TRADE_SKILL_REAGENTS, 1 do
			_G["TradeSkillReagent"..i]:Hide();
		end
	else
		TradeSkillSkillName:Show();
--		TradeSkillSkillLineName:Show();
		TradeSkillSkillIcon:Show();
		TradeSkillCollapseAllButton:Enable();
	end

	if ( rank < 75 ) and ( not IsTradeSkillLinked() ) then
		TradeSkillFrameEditBox:Hide();
		SetTradeSkillItemNameFilter("");	--In case they are switching from an inspect WITH a filter directly to their own without.
	else
		TradeSkillFrameEditBox:Show();
	end
	-- ScrollFrame update
	FauxScrollFrame_Update(TradeSkillListScrollFrame, numTradeSkills, TRADE_SKILLS_DISPLAYED, TRADE_SKILL_HEIGHT, nil, nil, nil, TradeSkillHighlightFrame, 293, 316 );
	
	TradeSkillHighlightFrame:Hide();
	local skillIndex, skillButton, skillButtonText, skillButtonCount;
	local nameWidth, countWidth;
	
	local skillNamePrefix = " ";
	for i=1, TRADE_SKILLS_DISPLAYED, 1 do
		skillIndex = i + skillOffset;
		skillButton = _G["TradeSkillSkill"..i];
		skillButtonText = _G["TradeSkillSkill"..i.."Text"];
		skillButtonCount = _G["TradeSkillSkill"..i.."Count"];
		if ( skillIndex <= numTradeSkills ) then
			skillName, skillType, numAvailable, isExpanded, altVerb = GetTradeSkillInfo(MyAddon.rdb[skillIndex].oldid);
			-- Set button widths if scrollbar is shown or hidden
			if ( TradeSkillListScrollFrame:IsShown() ) then
				skillButton:SetWidth(293);
			else
				skillButton:SetWidth(323);
			end
			local color = TradeSkillTypeColor[skillType];
			if ( color ) then
				skillButton:SetNormalFontObject(color.font);
				skillButtonCount:SetVertexColor(color.r, color.g, color.b);
				skillButton.r = color.r;
				skillButton.g = color.g;
				skillButton.b = color.b;
			end
			
			if ( ENABLE_COLORBLIND_MODE == "1" ) then
				skillNamePrefix = TradeSkillTypePrefix[skillType] or " ";
			end
			
			skillButton:SetID(MyAddon.rdb[skillIndex].oldid);
			skillButton:Show();
			-- Handle headers
			if ( skillType == "header" ) then
				skillButton:SetText(skillName);
				skillButtonText:SetWidth(TRADE_SKILL_TEXT_WIDTH);
				skillButtonCount:SetText("");
				if ( isExpanded ) then
					skillButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
				else
					skillButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
				end
				_G["TradeSkillSkill"..i.."Highlight"]:SetTexture("Interface\\Buttons\\UI-PlusButton-Hilight");
				_G["TradeSkillSkill"..i]:UnlockHighlight();
			else
				if ( not skillName ) then
					MyAddon.Updating = nil;
					return;
				end
				skillButton:SetNormalTexture("");
				_G["TradeSkillSkill"..i.."Highlight"]:SetTexture("");
				if ( numAvailable <= 0 ) then
					skillButton:SetText(skillNamePrefix..skillName);
					skillButtonText:SetWidth(TRADE_SKILL_TEXT_WIDTH);
					skillButtonCount:SetText(skillCountPrefix);
				else
					skillName = skillNamePrefix..skillName;
					skillButtonCount:SetText("["..numAvailable.."]");
					TradeSkillFrameDummyString:SetText(skillName);
					nameWidth = TradeSkillFrameDummyString:GetWidth();
					countWidth = skillButtonCount:GetWidth();
					skillButtonText:SetText(skillName);
					if ( nameWidth + 2 + countWidth > TRADE_SKILL_TEXT_WIDTH ) then
						skillButtonText:SetWidth(TRADE_SKILL_TEXT_WIDTH-2-countWidth);
					else
						skillButtonText:SetWidth(0);
					end
				end
				
				-- Place the highlight and lock the highlight state
				if ( GetTradeSkillSelectionIndex() == MyAddon.rdb[skillIndex].oldid ) then
					TradeSkillHighlightFrame:SetPoint("TOPLEFT", "TradeSkillSkill"..i, "TOPLEFT", 0, 0);
					TradeSkillHighlightFrame:Show();
					skillButtonCount:SetVertexColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
					skillButton:LockHighlight();
					skillButton.isHighlighted = true;
				else
					skillButton:UnlockHighlight();
					skillButton.isHighlighted = false;
				end
			end
			
		else
			skillButton:Hide();
		end
	end
	
	-- Set the expand/collapse all button texture
	local numHeaders = 0;
	local notExpanded = 0;
	for i=1, numTradeSkills, 1 do
		local skillName, skillType, numAvailable, isExpanded, altVerb = GetTradeSkillInfo(i);
		if ( skillName and skillType == "header" ) then
			numHeaders = numHeaders + 1;
			if ( not isExpanded ) then
				notExpanded = notExpanded + 1;
			end
		end
		if ( GetTradeSkillSelectionIndex() == i ) then
			-- Set the max makeable items for the create all button
			TradeSkillFrame.numAvailable = math.abs(numAvailable);
		end
	end
	-- If all headers are not expanded then show collapse button, otherwise show the expand button
	if ( notExpanded ~= numHeaders ) then
		TradeSkillCollapseAllButton.collapsed = nil;
		TradeSkillCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
	else
		TradeSkillCollapseAllButton.collapsed = 1;
		TradeSkillCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
	end
	
	MyAddon.Updating = nil;
	scandone = nil
end

function MyAddon:update(event,...)
	if not MyAddonframe.test:GetChecked() or not TradeSkillFrame:IsVisible() or MyAddonframe.updateframe:IsVisible() then
		-- addon not active
		return
	end
	
	-- addon is scaning, exit
	if MyAddon.Scanning then
		if not MyAddonframe.updateframe:IsVisible() then
			--print("addon busy, perform rescan in 1 seconds. (" .. event .. ")")
			MyAddonframe.updateframe:Show()
		end
		return
	end
	
	--print("Tradeskill Update by event: " .. event)
	MyAddon:Scan()
	TradeSkillFrame_Update()
end

function MyAddon:Scan()
	if MyAddon.Scanning then
		return
	end
	MyAddon.Scanning = true;
	MyAddon.Updating = true;
	
	if not MyAddon.ScanNr then
		MyAddon.ScanNr = 1
	else
		MyAddon.ScanNr = MyAddon.ScanNr + 1
	end
	
	MyAddon.cHeader = {}
	local Headers = {}
	local skillitems , skillheader= {} , {}
	local _
	local ids = {}
	local curHeader
	
	-- expand all headers
	for i= GetNumTradeSkills(), 1,-1 do
		skillitems = {}
		skillitems.skillName, skillitems.skillType, _, skillitems.isExpanded = GetTradeSkillInfo(i)
		if TradeSkillLevel[skillitems.skillType] == -1 then --header
			if not ids[skillitems.skillName] then 
				ids[skillitems.skillName] = 1
			else
				ids[skillitems.skillName] = ids[skillitems.skillName] +1
			end
			ids.id = ids[skillitems.skillName]
			curHeader = CURRENT_TRADESKILL..skillitems.skillName .. tostring(ids.id)
			if not MyAddon.header[curHeader] then
				--print(curHeader .. " not found, add them")
				MyAddon.header[curHeader] = 0
			end

			if skillitems.isExpanded == nil and MyAddon.header[curHeader] >= 0 then
				--print("expand header " .. curHeader)
				-- Collapsed, unscaned header found
				table.insert(MyAddon.cHeader, i)
				ExpandTradeSkillSubClass(i);
			end
		end
	end
	
	
	collids = {}
	for k,v in pairs(ids) do
		collids[k] = v
	end
	
	-- scan in collapsed headers with skillable skills
	for i=1, GetNumTradeSkills() do
		skillitems = {}
		skillitems.skillName, skillitems.skillType = GetTradeSkillInfo(i)

		if TradeSkillLevel[skillitems.skillType] == -1 then --header
			collids.id = collids[skillitems.skillName]
			collids[skillitems.skillName] = collids[skillitems.skillName] - 1
			curHeader = CURRENT_TRADESKILL..skillitems.skillName.. tostring(collids.id)
			if MyAddon.header[curHeader] >= 0 then
				MyAddon.header[curHeader] = -1
			end
		elseif TradeSkillLevel[skillitems.skillType] >= TradeSkillNeed and curHeader then
			MyAddon.header[curHeader] = 1
			curHeader = nil
		end
	end
	
	
	-- restore old status
	-- reverse sort
	table.sort(MyAddon.cHeader)
	for key, headerid in pairs(MyAddon.cHeader) do
		CollapseTradeSkillSubClass(headerid)
	end
	
	
	-- scan all shown skills
	MyAddon.rdb = {}
	local j = 1
	for i=1, GetNumTradeSkills() do
		skillitems = {}
		skillitems.skillName, skillitems.skillType = GetTradeSkillInfo(i)
		skillitems.oldid = i

		if TradeSkillLevel[skillitems.skillType] == -1 then -- header
			ids.id = ids[skillitems.skillName]
			ids[skillitems.skillName] = ids[skillitems.skillName] - 1
			curHeader = CURRENT_TRADESKILL..skillitems.skillName.. tostring(ids.id)
			if MyAddon.header[curHeader] > 0 then
				-- collapsed header with skills, add to list
				MyAddon.rdb[j] = skillitems
				j = j +1
			end
		elseif TradeSkillLevel[skillitems.skillType] >= TradeSkillNeed then
			MyAddon.rdb[j] = skillitems
			j = j +1
		end
	end
	
	-- reset selection
	local found
	local id = GetTradeSkillSelectionIndex()
	local skillName, skillType, numAvailable, isExpanded, altVerb
	if id then 
		skillName, skillType, numAvailable, isExpanded, altVerb = GetTradeSkillInfo(id);
	else
		skillType = "trivial"
	end
	
	--[[
	if skillType and not (TradeSkillLevel[skillType] >= TradeSkillNeed) then
		-- find first usable tradeskill
		for k,v in pairs(MyAddon.rdb) do
			if not found and v.skillType ~= "header" then
				found = true
				print("set selection to " .. v.skillName .." ".. tostring(v.oldid))
				TradeSkillFrame_SetSelection(v.oldid);
				SelectTradeSkill(v.oldid)
			end
		end
	end
	
	found = nil--]]

	MyAddon.Scanning = nil;
	MyAddon.Updating = nil;
	scandone = true
end

function MyAddon:InitFrames()

		-- main frame
		MyAddonframe.mainframe = CreateFrame("Frame", "CrafthelperFrame")
		MyAddonframe.mainframe:SetBackdrop({
			bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
			insets = { left= 4, right = 4, top = 4, bottom = 4 }
		})
		MyAddonframe.mainframe:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
		MyAddonframe.mainframe:SetHeight(66)
		MyAddonframe.mainframe:Hide()
		MyAddonframe.mainframe:Show()
		MyAddonframe.mainframe:ClearAllPoints()
		MyAddonframe.mainframe:SetParent(TradeSkillFrame)
		MyAddonframe.mainframe:SetPoint("TOPLEFT",TradeSkillFrame, "BOTTOMLEFT", 10,70)
		MyAddonframe.mainframe:SetPoint("TOPRIGHT",TradeSkillFrame, "BOTTOMRIGHT", -35,70)

		MyAddonframe.title = CreateFrame("Frame", "CrafthelperFrameTitle", MyAddonframe.mainframe)
		MyAddonframe.title:SetHeight(32)
		MyAddonframe.title:ClearAllPoints()
		MyAddonframe.title:SetPoint("TOPLEFT",MyAddonframe.mainframe, "TOPLEFT", 3,-3)
		MyAddonframe.title:SetPoint("TOPRIGHT",MyAddonframe.mainframe, "TOPRIGHT", -3,-3)
		MyAddonframe.title:SetBackdrop({
--			bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
			insets = { left= 4, right = 4, top = 4, bottom = 4 }
		})
		MyAddonframe.title:Show()
		MyAddonframe.title:SetBackdropBorderColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
--		MyAddonframe.title:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)

		MyAddonframe.title.Text = MyAddonframe.title:CreateFontString("CrafthelperFrameTitleText","BACKGROUND","GameFontNormal")
		MyAddonframe.title.Text:SetPoint("LEFT",10,0.5)
		MyAddonframe.title.Text:SetAlpha(1)
		MyAddonframe.title.Text:SetText("Crafthelper")
		
		MyAddonframe.title.about = MyAddonframe.title:CreateFontString("CrafthelperFrameTitleText","BACKGROUND","GameFontNormalSmall")
		MyAddonframe.title.about:SetPoint("LEFT",MyAddonframe.title.Text:GetWidth() + 10,0)
		MyAddonframe.title.about:SetAlpha(1)
		MyAddonframe.title.about:SetText(" - by Angelike (EU/Gilneas)")
		
		MyAddonframe.options = CreateFrame("Frame", "CrafthelperFrameOptions", MyAddonframe.mainframe)
		MyAddonframe.options:ClearAllPoints()
		MyAddonframe.options:SetPoint("TOPLEFT",MyAddonframe.mainframe, "TOPLEFT", 3,-3)
		MyAddonframe.options:SetPoint("TOPRIGHT",MyAddonframe.mainframe, "TOPRIGHT", -3,-3)
		MyAddonframe.options:SetPoint("BOTTOMLEFT",MyAddonframe.mainframe, "BOTTOMLEFT", 3,3)
		MyAddonframe.options:SetPoint("BOTTOMRIGHT",MyAddonframe.mainframe, "BOTTOMRIGHT", -3,3)
		MyAddonframe.options:SetBackdrop({
--			bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
			insets = { left= 4, right = 4, top = 4, bottom = 4 }
		})
		MyAddonframe.options:Show()
		MyAddonframe.options:SetBackdropBorderColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
		
		
		MyAddonframe.test = CreateFrame("CheckButton", "CraftHelperEnableButton", MyAddonframe.options , "UICheckButtonTemplate")
		MyAddonframe.test:ClearAllPoints()
		MyAddonframe.test:SetPoint("BOTTOMLEFT",MyAddonframe.mainframe, "BOTTOMLEFT", 7,7)
		MyAddonframe.test:Show()
		MyAddonframe.test:SetHeight(24)
		MyAddonframe.test:SetWidth(24)
		MyAddonframe.test:SetScript("OnClick", function()
			MyAddon:update();
			if not MyAddonframe.test:GetChecked() then
				TradeSkillFrame_Update()
			end
			if GetFirstTradeSkill() ~= GetTradeSkillSelectionIndex() then
				TradeSkillFrame_SetSelection(GetFirstTradeSkill());
			end
			TradeSkillFrame_Update()
		end)

		MyAddonframe.test.text = getglobal("CraftHelperEnableButtonText")
		MyAddonframe.test.text:SetText(L["only_show"])
		
		MyAddonframe.skill = CreateFrame("Frame", "CraftHelperSkillSelect", MyAddonframe.options , "UIDropDownMenuTemplate")
		UIDropDownMenu_Initialize(MyAddonframe.skill, MyAddon.InitSkillSelect)---, "MENU");
		UIDropDownMenu_SetSelectedValue(MyAddonframe.skill, 1);
		MyAddonframe.skill:ClearAllPoints()
		MyAddonframe.skill:SetPoint("TOPLEFT",MyAddonframe.mainframe, "TOPLEFT", 185,-32)
		MyAddonframe.skill:Show()
		MyAddonframe.skill:SetHeight(24)
		MyAddonframe.skill:SetWidth(24)
		MyAddonframe.skill:Show()
		
		-- this is just a throttler 
		MyAddonframe.updateframe = CreateFrame("Frame", "Crafthelper_Update_Frame")
		MyAddonframe.updateframe:SetScript("OnUpdate", function(this, timeSinceLast)
			timeSoFar = timeSoFar + timeSinceLast
			if timeSoFar > 1 then
				if stage == 0 then
					--print("execute scheduled update after " .. tostring(timeSoFar) .. " seconds") 
					MyAddon:Scan()
					TradeSkillFrame_Update()
					stage = 1
				end
				if timeSoFar > 1.5 then
--					print("Reset update after " .. tostring(timeSoFar) .. " seconds") 
					timeSoFar = 0
					stage = 0
					MyAddonframe.updateframe:Hide()
				end
			end
		end)
		MyAddonframe.updateframe:Hide()

	
end

function MyAddon:InitSkillSelect(this)
	local CraftHelperSkillSelect = MyAddonframe.skill
	local info = UIDropDownMenu_CreateInfo();
	table.sort(TradeSkillLevel)
	
	local selectedValue = UIDropDownMenu_GetSelectedValue(CraftHelperSkillSelect);
	if not selectedValue then
		TradeSkillNeed = 1
		selectedValue = 1
	end

	for name, level in pairs(TradeSkillLevel) do
		if level >= 0 then
			info.text = L[name];
			info.func = function(this) 
					if not this.value then
						return
					end
					UIDropDownMenu_SetSelectedValue(CraftHelperSkillSelect,this.value);
					if this.value < TradeSkillNeed then
						MyAddon.header = {}
					end
					TradeSkillNeed = this.value
					MyAddon:update()
					if not MyAddonframe.test:GetChecked() then
						if GetFirstTradeSkill() ~= GetTradeSkillSelectionIndex() then
							TradeSkillFrame_SetSelection(GetFirstTradeSkill());
						end
						TradeSkillFrame_Update()
					end
				end;
			info.value = level;
			info.tooltipTitle = L[name];
			info.tooltipText = L[name];
			if ( info.value == selectedValue ) then
				info.checked = 1;
			else
				info.checked = nil;
			end
			UIDropDownMenu_AddButton(info);
		end
	end
end

